/*******************************************************************************
 * Copyright (c) 2000, 2006 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 * Port to the D programming language:
 *     Frank Benoit <benoit@tionex.de>
 *******************************************************************************/
module dwtexamples.controlexample.CustomControlExample;


import dwt.layout.FillLayout;
import dwt.widgets.Composite;
import dwt.widgets.Display;
import dwt.widgets.Shell;

import dwtexamples.controlexample.ControlExample;
import dwtexamples.controlexample.CComboTab;
import dwtexamples.controlexample.CLabelTab;
import dwtexamples.controlexample.CTabFolderTab;
import dwtexamples.controlexample.SashFormTab;
import dwtexamples.controlexample.StyledTextTab;

import dwtexamples.controlexample.Tab;
import tango.io.Stdout;

version( CUSTOM_CONTROL_EXAMPLE_MAIN ){
    void main(){
        Stdout.formatln( "The CustomControlExample: still work left" );
        Stdout.formatln( "please report problems" );
        CustomControlExample.main( null );
    }
}

public class CustomControlExample : ControlExample {

    /**
     * Creates an instance of a CustomControlExample embedded
     * inside the supplied parent Composite.
     *
     * @param parent the container of the example
     */
    public this(Composite parent) {
        super (parent);
    }

    /**
     * Answers the set of example Tabs
     */
    Tab[] createTabs() {
        return [ cast(Tab)
            new CComboTab (this),
            new CLabelTab (this),
            new CTabFolderTab (this),
            new SashFormTab (this),
            new StyledTextTab (this)
        ];
    }

    /**
     * Invokes as a standalone program.
     */
    public static void main(char[][] args) {
        Stdout.formatln( "{}", __LINE__ );
        Display display = new Display();
        Stdout.formatln( "{}", __LINE__ );
        Shell shell = new Shell(display);
        Stdout.formatln( "{}", __LINE__ );
        shell.setLayout(new FillLayout());
        Stdout.formatln( "{}", __LINE__ );
        CustomControlExample instance = new CustomControlExample(shell);
        Stdout.formatln( "{}", __LINE__ );
        shell.setText(getResourceString("custom.window.title"));
        setShellSize(instance, shell);
        shell.open();
        while (! shell.isDisposed()) {
            if (! display.readAndDispatch()) display.sleep();
        }
        instance.dispose();
    }
}
